local lChat_OnEvent;
local LastRequest;
local LastStatus;
local Redirecting;
local RedirectTo;
local RedirSpam;
local RedirSpamB;
local LastBuff;

--Saved Variables
AIEnabled=1;
AIEnablePriest=0;
AIEnableMage=0;
AIEnableWarlock=0;
AIEnableShaman=0;
AIEnableDruid=0;
AIEnableHunter=0;
AIChatChannel="druidchat";
AISpamDelay=5;
TargetMinMana=2500;
AIRaidOnly=1;
AIAutoBuff=1;

--Constants
AIEnablePriestName="Priest";
AIEnableMageName="Mage";
AIEnableWarlockName="Warlock";
AIEnableShamanName="Shaman";
AIEnableDruidName="Druid";
AIEnableHunterName="Hunter";
AIVersion="2.20";

--Init Function
function ImpInnervate()
 DEFAULT_CHAT_FRAME:AddMessage("Adune's Improved Innervate "..AIVersion.." loaded.");
 DEFAULT_CHAT_FRAME:AddMessage("Use /aio for options");
 SLASH_SINNERVATE1="/sinnervate";
 SLASH_AIOPTIONS1="/aio";
 SlashCmdList["SINNERVATE"]= SmartInnervate;
 SlashCmdList["AIOPTIONS"]= AIOptions;
 this:RegisterEvent("VARIABLES_LOADED");
 --Hook into chat messgaes
 lChat_OnEvent=ChatFrame_OnEvent;
 ChatFrame_OnEvent=Adune_Chat_GetTell;
 --Initialize anti-spam values
 Redirecting=false;
 LastRequest=GetTime();
 LastStatus=GetTime();
 RedirSpam=GetTime();
 RedirSpamB=GetTime();
 LastBuff=GetTime();
 
 --Init popup messages
 StaticPopupDialogs["Innervate_Confirm"]=
{
	text="Do you want to innervate %s?",
	button1="Yes", 
	button2="No",
	OnAccept=function(Sender)
		AutoInnervate(Sender);
	end,
	OnCancel=function(Sender)
		DeclineInnervate(Sender);
	end,
	sound="levelup2",
	timeout=0,
	whileDead=1,
	hideOnEscape=1
};

 StaticPopupDialogs["Raid_Innervate_Confirm"]=
{
	text="Do you want to innervate %s?",
	button1="Yes", 
	button2="No",
	OnAccept=function(Sender)
		AutoInnervateRaid(Sender);
	end,
	OnCancel=function(Sender)
		DeclineInnervate(Sender);
	end,
	sound="levelup2",
	timeout=0,
	whileDead=1,
	hideOnEscape=1
};

StaticPopupDialogs["Buff_Confirm"]=
{
	text="Cast %s on %s?",
	button1="Yes", 
	button2="No",
	OnAccept=function()
		CastSpellByName("Mark of the Wild");
	end,
	OnCancel=function(plr)
		SendChatMessage("Buff request DENIED!","WHISPER",nil,plr);
	end,
	sound="levelup2",
	timeout=10,
	whileDead=1,
	hideOnEscape=1
};
end

function AIOptions()
	AIOptions_Show();
end

--Unused function.  To use if I need to attach any events to the mod loading
function AIFrame_OnEvent(event)
	if (event=="VARIABLES_LOADED") then
	end
		
end

function WriteLine(value)
	DEFAULT_CHAT_FRAME:AddMessage(value);
end

--Function to return true if in raid
function AIRaidID(PlayerName)
	i=1;
	if UnitInRaid("player") then
		--Iterate through the raid searching for the end, or the player.
		while (UnitName("raid"..i)~=PlayerName and UnitName("raid"..i)~=nil) do
			i=i+1;
		end
		if UnitName("raid"..i)==PlayerName then
			return i;
		end
	else
		return 0;
	end
end

--Get the Spell ID of the specified spell
function GetSpellID(SpellName)
	local SpellCount=0;
	local SpellID=0;
	local ReturnName;
	while (ReturnName~=SpellName) do
		SpellCount=SpellCount +1;
		ReturnName=GetSpellName(SpellCount,BOOKTYPE_SPELL);
		
	end
	if (SpellName == ReturnName) then
		SpellID=SpellCount;
	end
	return SpellID
end


function SmartInnervate()
	if (UnitName("target")==nil) then
		DEFAULT_CHAT_FRAME:AddMessage("You have no target selected!  Smart Innervate will not perform checking!");
		CastSpellByName("Innervate");
	else
		if not (UnitIsFriend("player","target") and UnitIsPlayer("target")) then
			DEFAULT_CHAT_FRAME:AddMessage("Only friendly players can be Innervated!");
		else
		InnervateTarget=UnitName("target");
		
		local InnerID=GetSpellID("Innervate");
		if (InnerID==0) then
			DEFAULT_CHAT_FRAME:AddMessage("You do not have the spell Innervate!");
		else
			local SStart, SEnd=GetSpellCooldown(InnerID, "SPELL");
			if SStart>0 then
				local TimeRemain=SEnd-(GetTime()-SStart);
				DEFAULT_CHAT_FRAME:AddMessage("Innervate is not up!  "..string.format("%.0f",TimeRemain).." seconds until it's up.");
			else
				
					if (UnitManaMax("target")<200) then
						DEFAULT_CHAT_FRAME:AddMessage("It's generally considered stupid to Innervate a class that doesn't have mana.");
					else
						if (UnitMana("target")>TargetMinMana) then
							DEFAULT_CHAT_FRAME:AddMessage("Target has more than "..TargetMinMana.." Mana.");
						else
							if (CheckInteractDistance("target",4)) then
								local InnervFound=false;
								for i=1,16 do
									local texture=UnitBuff("target",i);
									if (texture~=nil) then
										if (string.find(texture,"Spell_Nature_Lightning")) then
											InnervFound=true;
										end
									end
								end
								if InnervFound then
									DEFAULT_CHAT_FRAME:AddMessage(InnervateTarget.." is already Innervated.");
								else
									--Cast Innervate.
									local FeralForm=false;
									for i=1,4 do
										icon, name, active = GetShapeshiftFormInfo(i);
										if (active~=nil) then
											FeralForm=true;
										end
									end
									if FeralForm then
										DEFAULT_CHAT_FRAME:AddMessage("Cannot Innervate: In Feral.");
									else
										CastSpell(InnerID, "SPELL");
									SendChatMessage("Innervating "..InnervateTarget,"CHANNEL",nil,GetChannelName(AIChatChannel));
									SendChatMessage("** Innervating "..InnervateTarget.."**","RAID");
									SendChatMessage("Innervating "..InnervateTarget,"WHISPER",nil,InnervateTarget);
									end
									
								end
								
							else
								DEFAULT_CHAT_FRAME:AddMessage("Out of range to cast Innervate!");
							end
						end
					end
				
			end
		end
		end
	end
end

function DeclineInnervate(InnervateTarget)
if (InnervateTarget) then
	SendChatMessage("Your innervate request has been denied.","WHISPER",nil,InnervateTarget);
end
end

function AutoInnervate(InnervateTarget)
	if (InnervateTarget) then
		TargetByName(InnervateTarget, true);
		if (UnitName("target")~=InnervateTarget) then
			SendChatMessage("Cannot target you for Innervate.","WHISPER",nil,InnervateTarget);
		else
			if ((UnitClass("target")==AIEnablePriestName) and AIEnablePriest==1) or ((UnitClass("target")==AIEnableMageName) and AIEnableMage==1) or ((UnitClass("target")==AIEnableWarlockName) and AIEnableWarlock==1) or ((UnitClass("target")==AIEnableShamanName) and AIEnableShaman==1) or ((UnitClass("target")==AIEnableDruidName) and AIEnableDruid==1)or ((UnitClass("target")==AIEnableHunterName) and AIEnableHunter==1)then
				if (UnitMana("target")>TargetMinMana) then
					SendChatMessage("You can only request an auto Innervate below "..TargetMinMana.." mana.","WHISPER",nil,InnervateTarget);
				else
					if (CheckInteractDistance("target",4)) then
						local InnervFound=false;
						for i=1,16 do
							local texture=UnitBuff("target",i);
							if (texture~=nil) then
								if (string.find(texture,"Spell_Nature_Lightning")) then
									InnervFound=true;
								end
							end
						end
						if InnervFound then
							SendChatMessage("You are already Innervated.","WHISPER",nil,InnervateTarget);
						else
							--Cast Innervate.
							local FeralForm=false;
							for i=1,4 do
								icon, name, active = GetShapeshiftFormInfo(i);
								if (active~=nil) then
									FeralForm=true;
								end
							end
							if FeralForm then
								SendChatMessage("Cannot Innervate: In Feral.","WHISPER",nil,InnervateTarget);
							else
								CastSpellByName("Innervate");
								SendChatMessage("Innervating "..InnervateTarget,"CHANNEL",nil,GetChannelName(AIChatChannel));
								SendChatMessage("** Innervating "..InnervateTarget.."**","RAID");
							end
						end
					else
						SendChatMessage("Out of range to cast Innervate!","WHISPER",nil,InnervateTarget);
					end
				end
			else
				SendChatMessage("Your class cannot auto request innervates.","WHISPER",nil,InnervateTarget);
			end
		end
	end
end

function AutoInnervateRaid(InnervateTarget)
	if (InnervateTarget) then
		TargetByName(InnervateTarget, true);
		if (UnitName("target")~=InnervateTarget) then
			SendChatMessage("Cannot target you for Innervate.","WHISPER",nil,InnervateTarget);
		else
			if (CheckInteractDistance("target",4)) then
				local InnervFound=false;
				for i=1,16 do
					local texture=UnitBuff("target",i);
					if (texture~=nil) then
						if (string.find(texture,"Spell_Nature_Lightning")) then
							InnervFound=true;
						end
					end
				end
				if InnervFound then
					SendChatMessage("You are already Innervated.","WHISPER",nil,InnervateTarget);
				else
					--Cast Innervate.
					local FeralForm=false;
					for i=1,4 do
						icon, name, active = GetShapeshiftFormInfo(i);
						if (active~=nil) then
							FeralForm=true;
						end
					end
					if FeralForm then
						SendChatMessage("Cannot Innervate: In Feral.","WHISPER",nil,InnervateTarget);
					else
						CastSpellByName("Innervate");
						SendChatMessage("Innervating "..InnervateTarget,"CHANNEL",nil,GetChannelName(AIChatChannel));
						SendChatMessage("** Innervating "..InnervateTarget.."**","RAID");
					end
				end
			else
				SendChatMessage("Out of range to cast Innervate!","WHISPER",nil,InnervateTarget);
			end
		end
	end
end


function Adune_Chat_GetTell(event)

	local Chathooked=false;
	
	if (AIEnabled==1) and (strsub(event,1)=="CHAT_MSG_CHANNEL") then
		if (string.lower(arg9)==AIChatChannel) then
			if (string.lower(arg1)=="status") then
				Chathooked=true;
				if ((GetTime()-LastStatus)<AISpamDelay) then
					--Do Nothing.
					--DEFAULT_CHAT_FRAME:AddMessage("WTFNESS!");
				else
					LastStatus=GetTime();
					local SStart, SEnd=GetSpellCooldown(GetSpellID("Innervate"), "SPELL");
					local TimeRemain=SEnd-(GetTime()-SStart);
					local ChatMsg;
					if (SStart>0) then
						ChatMsg="Inn DOWN:"..string.format("%.0f",TimeRemain).." s/";
					else
						ChatMsg="Innervate UP  /";
					end
					if (UnitIsDeadOrGhost("player")) then
						ChatMsg="DEAD/"..ChatMsg;
					end
					SStart, SEnd=GetSpellCooldown(GetSpellID("Rebirth"), "SPELL");
					TimeRemain=SEnd-(GetTime()-SStart);
					if (SStart>0) then
						ChatMsg=ChatMsg.."BR DOWN:"..string.format("%.0f",TimeRemain).." s";
					else
						ChatMsg=ChatMsg.."Battle Rez UP";
					end
					SendChatMessage(ChatMsg,"CHANNEL",nil,GetChannelName(AIChatChannel));
				end
			end
		end
	end
	
	if (AIEnabled==1) and (strsub(event,1)=="CHAT_MSG_CHANNEL") then
		if (string.lower(arg9)==AIChatChannel) then
			if (arg1=="REQREDIRECT") then
			Chathooked=true;
			if ((GetTime()-RedirSpam)>2) then
				RedirSpam=GetTime();
				if (UnitIsDeadOrGhost("player")) then
					--Do Nothing
				else
					local SStart, SEnd=GetSpellCooldown(GetSpellID("Innervate"), "SPELL");
					local TimeRemain=SEnd-(GetTime()-SStart);
					if (SStart==0) then
						SendChatMessage("REQREDIRECTYES","CHANNEL",nil,GetChannelName(AIChatChannel));
					end
				end				
			end
			end
		end
	end
	
	if (AIEnabled==1) and (strsub(event,1)=="CHAT_MSG_CHANNEL") then
		if (string.lower(arg9)==AIChatChannel) then
			if (Redirecting and (arg1=="REQREDIRECTYES") and AIRaidID(arg2)~=nil) then
				Chathooked=true;
				Redirecting=false;
				SendChatMessage("REQREDIRTO: "..RedirectTo,"WHISPER",nil,arg2);
			end
		end
	end
	
	if (AIEnabled==1) and (strsub(event,1)=="CHAT_MSG_WHISPER") then
		local msg=arg1;
		local plr;
		if ((GetTime()-RedirSpamB)>2) then
			RedirSpamB=GetTime();
			if (strsub(msg,1,11)=="REQREDIRTO:") then
				Chathooked=true;
				plr=strsub(msg,13);
				local InnerID=GetSpellID("Innervate");
				SendChatMessage("Processing redirect request for "..plr,"CHANNEL",nil,GetChannelName(AIChatChannel));
				local dialog = StaticPopup_Show("Innervate_Confirm", plr);
				if (dialog) then
					dialog.data=plr;
				end
			end
		end
	end
	
	if (AIEnabled==1) and (strsub(event,1)=="CHAT_MSG_WHISPER") then
		local msg=arg1;
		local plr=arg2;
		if (strsub(string.lower(msg),1,9)=="innervate") then
			Chathooked=true;
			if ((GetTime()-LastRequest)<AISpamDelay) then
				--Do Nothing, Spam delay
			else
			local PlayerRaidID=AIRaidID(plr)
			if (AIRaidOnly==1 and PlayerRaidID==nil) then
				--Do Nothing, they're not in the raid.
			else
				if UnitIsDeadOrGhost("player") then
					SendChatMessage("I'm dead!  Redirecting...","WHISPER",nil,plr);
					SendChatMessage("REQREDIRECT","CHANNEL",nil,GetChannelName(AIChatChannel));
					Redirecting=true;
					RedirectTo=plr;
					RedirSpam=GetTime();
				else
					LastRequest=GetTime();
					local InnerID=GetSpellID("Innervate");
					if (InnerID==0) then
						SendChatMessage("Player is not a druid!","WHISPER",nil,plr);
					else
						local SStart, SEnd=GetSpellCooldown(InnerID, "SPELL");
						if SStart>2 then
							local TimeRemain=SEnd-(GetTime()-SStart);
							SendChatMessage("Innervate is not up!  "..string.format("%.0f",TimeRemain).." seconds until it's up: Redirecting...","WHISPER",nil,plr);
							SendChatMessage("REQREDIRECT","CHANNEL",nil,GetChannelName(AIChatChannel));
							Redirecting=true;
							RedirectTo=plr;
							RedirSpam=GetTime();
						else
							if (AIRaidOnly==1) then
								if ((UnitClass("raid"..PlayerRaidID)==AIEnablePriestName) and AIEnablePriest==1) or ((UnitClass("raid"..PlayerRaidID)==AIEnableMageName) and AIEnableMage==1) or ((UnitClass("raid"..PlayerRaidID)==AIEnableWarlockName) and AIEnableWarlock==1) or ((UnitClass("raid"..PlayerRaidID)==AIEnableShamanName) and AIEnableShaman==1) or ((UnitClass("raid"..PlayerRaidID)==AIEnableDruidName) and AIEnableDruid==1)or ((UnitClass("raid"..PlayerRaidID)==AIEnableHunterName) and AIEnableHunter==1)then
									if (UnitMana("raid"..PlayerRaidID)>TargetMinMana) then
										SendChatMessage("You can only request an auto Innervate below "..TargetMinMana.." mana.","WHISPER",nil,plr);
									else
										SendChatMessage(arg2.." has auto requested an Innervate.","CHANNEL",nil,GetChannelName(AIChatChannel));
										local dialog = StaticPopup_Show("Raid_Innervate_Confirm", arg2);
										if (dialog) then
											dialog.data=arg2;
										end
									end
								end
							else
								SendChatMessage(arg2.." has auto requested an Innervate.","CHANNEL",nil,GetChannelName(AIChatChannel));
								local dialog = StaticPopup_Show("Innervate_Confirm", arg2);
								if (dialog) then
									dialog.data=arg2;
								end
							end
						end
					end
				end --IfUnitDeadorGhost
			end
			end
		end
	end
	
	if (strsub(event,1)=="CHAT_MSG_WHISPER") then
		local msg=arg1;
		local plr=arg2;
		if ((GetTime()-LastBuff)>AISpamDelay) and AIAutoBuff==1 and ((string.find(msg,"mow")~=nil) or (string.find(msg,"mark")~=nil) or (string.find(msg,"motw")~=nil) or (string.find(msg,"wild")~=nil))then
			LastBuff=GetTime();
			Chathooked=true;
			TargetByName(plr, true);
			local dialog = StaticPopup_Show("Buff_Confirm", "Mark of the Wild",plr);
			if (dialog) then
				dialog.data=plr;
			end
		end
	end
	
	if (Redirecting and (GetTime()-RedirSpam)>5) then
		SendChatMessage("No druids available to take the redirect:  NO INNERVATE FOR YOU.","WHISPER",nil,RedirectTo);
		Redirecting=false;
		RedirectTo=nil;
	end
	
	if (Chathooked==false) then
		lChat_OnEvent(event);
	end
end